/* The MazezaM Engine 
 * Copyright (C) 2002-2008 Malcolm Tyrrell
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package applet;

import globals.Globals;
import globals.SettingsManager;
import gui_common.OutermostPanel;

import javax.swing.JApplet;

import core.GameSwitcher;


/**
 * The outer frame of the applet, also the class containing init().
 */
public class AppletFrame extends JApplet {
	OutermostPanel panel;

	public void init() {
		Globals.initialise_applet(this);
		
		// assign good default values to the settings
		SettingsManager.restoreSettings();
		SettingsManager.restoreKeySettings();

		// Override the settings with any appropriate settings
		// in the applet parameters.
		SettingsManager.accessSettings();
		SettingsManager.accessKeySettings();
		
		GameSwitcher gs = new GameSwitcher();
		panel = new OutermostPanel(gs);
		gs.action_appletLoad();
		setContentPane(panel);
	}

	public void stop() {
		if (panel != null) {
			getContentPane().remove(panel);
			panel = null;
		}
	}

	/**
	 * I've decided not to bother with this!
	 */
	public String[][] getParameterInfo() {
		return new String[0][0];
	}
}
