/* The MazezaM Engine 
 * Copyright (C) 2002-2008 Malcolm Tyrrell
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package core;

import tessellation.Position;

/**
 * A player action which indicates that the player clicked on a specific position.
 */
class PositionSelectionPlayerAction implements PlayerAction {
	private int player_number;
	private Position the_position;

	public PositionSelectionPlayerAction(int p,Position pos) {
		player_number = p;
		the_position = pos;
	}

	public boolean attemptAction(LevelInterface l) {
		return l.attempt_selectAt(player_number,the_position);
	}

}
