/* The MazezaM Engine 
 * Copyright (C) 2002-2008 Malcolm Tyrrell
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package level;

import java.awt.geom.Area;

import tessellation.Position;

/**
 * A floor tile onto which blocks cannot be pushed.
 * Used in MazezaM to block the exit.
 */
public class NoBlocks extends UnitFloor {
	public NoBlocks() {
		super(Unit.noBlocks, new UnitPaint_noBlocks(0));
	}

	void paintInto(UnitGraphics g, Position rel, int superSelection) {
		g.setPaint(unit_paint.getPaint());
		Area a = new Area(g.unitOutline(rel));
		a.subtract(new Area(g.unitCircle(rel)));
		g.fill(a);
	}
}