/* The MazezaM Engine 
 * Copyright (C) 2002-2008 Malcolm Tyrrell
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package level;

import tessellation.Position;

/**
 * An abstract class which provides an interface for shapes and floors
 */
abstract class UnitObject extends UnitContainer {
	/**
	 * requests this shape to paint itself using the supplied UnitGraphics
	 * object, at the given position.
	 */
	abstract void paintInto(UnitGraphics g, Position rel, int selected);

	/**
	 * Returns a clone of the current object
	 */
	/*
	 * FIXME Think I was wrong to do deep clones everywhere Cloning is used to
	 * keep copies of the levels for undoing or resetting, and therefore only
	 * those parts of the structures which change need to be different between
	 * the two instances. Think about this!
	 */
	public Object clone() {
		UnitObject new_instance = (UnitObject) super.clone();
		if (unit_paint != null)
			new_instance.unit_paint = (UnitPaint) unit_paint.clone();
		return new_instance;
	}

	UnitPaint unit_paint;
}
