/* The MazezaM Engine 
 * Copyright (C) 2002-2008 Malcolm Tyrrell
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package level;

import java.util.Iterator;
import java.util.LinkedList;

import tessellation.Position;

/**
 * A list of units, shapes and positions which is used in several algorithms.
 */
public class UnitShapePosList extends LinkedList<UnitShapePosPair> {
	LinkedList<Position> nonEmptyPositions() {
		LinkedList<Position> l = new LinkedList<Position>();
		Iterator<UnitShapePosPair> spi;
		UnitShapePosPair sp;
		Iterator<Position> pi;
		for (spi = iterator(); spi.hasNext();) {
			sp = spi.next();
			for (pi = sp.shape.nonEmptyPositions().iterator(); pi.hasNext();) {
				l.add(sp.pos.plus(pi.next()));
			}
		}
		return l;
	}
}
